#include <stdio.h>
#include <stdlib.h>

int main(int argc, char* argv[])                              /* (A) */
{
    FILE *in, *out;                                           /* (B) */
    int ch;

    if ( argc != 3 ) {                                        /* (C) */
        fprintf( stderr, "usage: copy in_file out_file\n" );   
        exit( EXIT_FAILURE );                               
    }
  
    if ( ( fopen_s(&in,argv[1], "rb" ) ) != 0 ) {             /* (D) */
        fprintf( stderr, "Can't open %s\n", argv[1] );      
        exit( EXIT_FAILURE );                               
    }

    if ( ( fopen_s(&out,argv[2], "wb" ) ) != 0 ) {            /* (E) */
        fprintf( stderr, "Can't open %s\n", argv[2] );      
        fclose( in );                                
        exit( EXIT_FAILURE );                               
    }

    while ( ( ch = getc( in ) ) != EOF )                      /* (F) */
        if ( putc( ch, out ) == EOF )                         /* (G) */
            break;                                          
 
    if ( ferror( in ) )                                       /* (H) */
        printf( "Error while reading source file.\n" );     
    if ( ferror( out ) )                                      /* (I) */
        printf( "Error while writing into dest file.\n" );  

    fclose( in );                                             /* (J) */
    fclose( out );                                            /* (K) */
    return 0;
}